# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetAgentAgentVersionsResult',
    'AwaitableGetAgentAgentVersionsResult',
    'get_agent_agent_versions',
    'get_agent_agent_versions_output',
]

@pulumi.output_type
class GetAgentAgentVersionsResult:
    """
    A collection of values returned by getAgentAgentVersions.
    """
    def __init__(__self__, agent_id=None, agent_version_summaries=None, id=None):
        if agent_id and not isinstance(agent_id, str):
            raise TypeError("Expected argument 'agent_id' to be a str")
        pulumi.set(__self__, "agent_id", agent_id)
        if agent_version_summaries and not isinstance(agent_version_summaries, list):
            raise TypeError("Expected argument 'agent_version_summaries' to be a list")
        pulumi.set(__self__, "agent_version_summaries", agent_version_summaries)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="agentId")
    def agent_id(self) -> str:
        return pulumi.get(self, "agent_id")

    @property
    @pulumi.getter(name="agentVersionSummaries")
    def agent_version_summaries(self) -> Optional[Sequence['outputs.GetAgentAgentVersionsAgentVersionSummaryResult']]:
        """
        List of objects, each of which contains information about a version of the agent. See Agent Version Summaries
        """
        return pulumi.get(self, "agent_version_summaries")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")


class AwaitableGetAgentAgentVersionsResult(GetAgentAgentVersionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAgentAgentVersionsResult(
            agent_id=self.agent_id,
            agent_version_summaries=self.agent_version_summaries,
            id=self.id)


def get_agent_agent_versions(agent_id: Optional[str] = None,
                             agent_version_summaries: Optional[Sequence[Union['GetAgentAgentVersionsAgentVersionSummaryArgs', 'GetAgentAgentVersionsAgentVersionSummaryArgsDict']]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAgentAgentVersionsResult:
    """
    Data source for managing an AWS Amazon BedrockAgent Agent Versions.

    ## Example Usage

    ### Basic Usage

    ```python
    import pulumi
    import pulumi_aws as aws

    test = aws.bedrock.get_agent_agent_versions(agent_id=test_aws_bedrockagent_agent["agentId"])
    ```


    :param str agent_id: Unique identifier of the agent.
    :param Sequence[Union['GetAgentAgentVersionsAgentVersionSummaryArgs', 'GetAgentAgentVersionsAgentVersionSummaryArgsDict']] agent_version_summaries: List of objects, each of which contains information about a version of the agent. See Agent Version Summaries
    """
    __args__ = dict()
    __args__['agentId'] = agent_id
    __args__['agentVersionSummaries'] = agent_version_summaries
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws:bedrock/getAgentAgentVersions:getAgentAgentVersions', __args__, opts=opts, typ=GetAgentAgentVersionsResult).value

    return AwaitableGetAgentAgentVersionsResult(
        agent_id=pulumi.get(__ret__, 'agent_id'),
        agent_version_summaries=pulumi.get(__ret__, 'agent_version_summaries'),
        id=pulumi.get(__ret__, 'id'))


@_utilities.lift_output_func(get_agent_agent_versions)
def get_agent_agent_versions_output(agent_id: Optional[pulumi.Input[str]] = None,
                                    agent_version_summaries: Optional[pulumi.Input[Optional[Sequence[Union['GetAgentAgentVersionsAgentVersionSummaryArgs', 'GetAgentAgentVersionsAgentVersionSummaryArgsDict']]]]] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAgentAgentVersionsResult]:
    """
    Data source for managing an AWS Amazon BedrockAgent Agent Versions.

    ## Example Usage

    ### Basic Usage

    ```python
    import pulumi
    import pulumi_aws as aws

    test = aws.bedrock.get_agent_agent_versions(agent_id=test_aws_bedrockagent_agent["agentId"])
    ```


    :param str agent_id: Unique identifier of the agent.
    :param Sequence[Union['GetAgentAgentVersionsAgentVersionSummaryArgs', 'GetAgentAgentVersionsAgentVersionSummaryArgsDict']] agent_version_summaries: List of objects, each of which contains information about a version of the agent. See Agent Version Summaries
    """
    ...
