# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['SdkvoiceGlobalSettingsArgs', 'SdkvoiceGlobalSettings']

@pulumi.input_type
class SdkvoiceGlobalSettingsArgs:
    def __init__(__self__, *,
                 voice_connector: pulumi.Input['SdkvoiceGlobalSettingsVoiceConnectorArgs']):
        """
        The set of arguments for constructing a SdkvoiceGlobalSettings resource.
        :param pulumi.Input['SdkvoiceGlobalSettingsVoiceConnectorArgs'] voice_connector: The Voice Connector settings. See voice_connector.
        """
        pulumi.set(__self__, "voice_connector", voice_connector)

    @property
    @pulumi.getter(name="voiceConnector")
    def voice_connector(self) -> pulumi.Input['SdkvoiceGlobalSettingsVoiceConnectorArgs']:
        """
        The Voice Connector settings. See voice_connector.
        """
        return pulumi.get(self, "voice_connector")

    @voice_connector.setter
    def voice_connector(self, value: pulumi.Input['SdkvoiceGlobalSettingsVoiceConnectorArgs']):
        pulumi.set(self, "voice_connector", value)


@pulumi.input_type
class _SdkvoiceGlobalSettingsState:
    def __init__(__self__, *,
                 voice_connector: Optional[pulumi.Input['SdkvoiceGlobalSettingsVoiceConnectorArgs']] = None):
        """
        Input properties used for looking up and filtering SdkvoiceGlobalSettings resources.
        :param pulumi.Input['SdkvoiceGlobalSettingsVoiceConnectorArgs'] voice_connector: The Voice Connector settings. See voice_connector.
        """
        if voice_connector is not None:
            pulumi.set(__self__, "voice_connector", voice_connector)

    @property
    @pulumi.getter(name="voiceConnector")
    def voice_connector(self) -> Optional[pulumi.Input['SdkvoiceGlobalSettingsVoiceConnectorArgs']]:
        """
        The Voice Connector settings. See voice_connector.
        """
        return pulumi.get(self, "voice_connector")

    @voice_connector.setter
    def voice_connector(self, value: Optional[pulumi.Input['SdkvoiceGlobalSettingsVoiceConnectorArgs']]):
        pulumi.set(self, "voice_connector", value)


class SdkvoiceGlobalSettings(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 voice_connector: Optional[pulumi.Input[Union['SdkvoiceGlobalSettingsVoiceConnectorArgs', 'SdkvoiceGlobalSettingsVoiceConnectorArgsDict']]] = None,
                 __props__=None):
        """
        Resource for managing Amazon Chime SDK Voice Global Settings.

        ## Example Usage

        ### Basic Usage

        ```python
        import pulumi
        import pulumi_aws as aws

        example = aws.chime.SdkvoiceGlobalSettings("example", voice_connector={
            "cdr_bucket": "example-bucket-name",
        })
        ```

        ## Import

        Using `pulumi import`, import AWS Chime SDK Voice Global Settings using the `id` (AWS account ID). For example:

        ```sh
        $ pulumi import aws:chime/sdkvoiceGlobalSettings:SdkvoiceGlobalSettings example 123456789012
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['SdkvoiceGlobalSettingsVoiceConnectorArgs', 'SdkvoiceGlobalSettingsVoiceConnectorArgsDict']] voice_connector: The Voice Connector settings. See voice_connector.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SdkvoiceGlobalSettingsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource for managing Amazon Chime SDK Voice Global Settings.

        ## Example Usage

        ### Basic Usage

        ```python
        import pulumi
        import pulumi_aws as aws

        example = aws.chime.SdkvoiceGlobalSettings("example", voice_connector={
            "cdr_bucket": "example-bucket-name",
        })
        ```

        ## Import

        Using `pulumi import`, import AWS Chime SDK Voice Global Settings using the `id` (AWS account ID). For example:

        ```sh
        $ pulumi import aws:chime/sdkvoiceGlobalSettings:SdkvoiceGlobalSettings example 123456789012
        ```

        :param str resource_name: The name of the resource.
        :param SdkvoiceGlobalSettingsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SdkvoiceGlobalSettingsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 voice_connector: Optional[pulumi.Input[Union['SdkvoiceGlobalSettingsVoiceConnectorArgs', 'SdkvoiceGlobalSettingsVoiceConnectorArgsDict']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SdkvoiceGlobalSettingsArgs.__new__(SdkvoiceGlobalSettingsArgs)

            if voice_connector is None and not opts.urn:
                raise TypeError("Missing required property 'voice_connector'")
            __props__.__dict__["voice_connector"] = voice_connector
        super(SdkvoiceGlobalSettings, __self__).__init__(
            'aws:chime/sdkvoiceGlobalSettings:SdkvoiceGlobalSettings',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            voice_connector: Optional[pulumi.Input[Union['SdkvoiceGlobalSettingsVoiceConnectorArgs', 'SdkvoiceGlobalSettingsVoiceConnectorArgsDict']]] = None) -> 'SdkvoiceGlobalSettings':
        """
        Get an existing SdkvoiceGlobalSettings resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['SdkvoiceGlobalSettingsVoiceConnectorArgs', 'SdkvoiceGlobalSettingsVoiceConnectorArgsDict']] voice_connector: The Voice Connector settings. See voice_connector.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SdkvoiceGlobalSettingsState.__new__(_SdkvoiceGlobalSettingsState)

        __props__.__dict__["voice_connector"] = voice_connector
        return SdkvoiceGlobalSettings(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="voiceConnector")
    def voice_connector(self) -> pulumi.Output['outputs.SdkvoiceGlobalSettingsVoiceConnector']:
        """
        The Voice Connector settings. See voice_connector.
        """
        return pulumi.get(self, "voice_connector")

