# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'LinkLinkConfigurationArgs',
    'LinkLinkConfigurationArgsDict',
    'LinkLinkConfigurationLogGroupConfigurationArgs',
    'LinkLinkConfigurationLogGroupConfigurationArgsDict',
    'LinkLinkConfigurationMetricConfigurationArgs',
    'LinkLinkConfigurationMetricConfigurationArgsDict',
]

MYPY = False

if not MYPY:
    class LinkLinkConfigurationArgsDict(TypedDict):
        log_group_configuration: NotRequired[pulumi.Input['LinkLinkConfigurationLogGroupConfigurationArgsDict']]
        """
        Configuration for filtering which log groups are to send log events from the source account to the monitoring account. See `log_group_configuration` Block for details.
        """
        metric_configuration: NotRequired[pulumi.Input['LinkLinkConfigurationMetricConfigurationArgsDict']]
        """
        Configuration for filtering which metric namespaces are to be shared from the source account to the monitoring account. See `metric_configuration` Block for details.
        """
elif False:
    LinkLinkConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class LinkLinkConfigurationArgs:
    def __init__(__self__, *,
                 log_group_configuration: Optional[pulumi.Input['LinkLinkConfigurationLogGroupConfigurationArgs']] = None,
                 metric_configuration: Optional[pulumi.Input['LinkLinkConfigurationMetricConfigurationArgs']] = None):
        """
        :param pulumi.Input['LinkLinkConfigurationLogGroupConfigurationArgs'] log_group_configuration: Configuration for filtering which log groups are to send log events from the source account to the monitoring account. See `log_group_configuration` Block for details.
        :param pulumi.Input['LinkLinkConfigurationMetricConfigurationArgs'] metric_configuration: Configuration for filtering which metric namespaces are to be shared from the source account to the monitoring account. See `metric_configuration` Block for details.
        """
        if log_group_configuration is not None:
            pulumi.set(__self__, "log_group_configuration", log_group_configuration)
        if metric_configuration is not None:
            pulumi.set(__self__, "metric_configuration", metric_configuration)

    @property
    @pulumi.getter(name="logGroupConfiguration")
    def log_group_configuration(self) -> Optional[pulumi.Input['LinkLinkConfigurationLogGroupConfigurationArgs']]:
        """
        Configuration for filtering which log groups are to send log events from the source account to the monitoring account. See `log_group_configuration` Block for details.
        """
        return pulumi.get(self, "log_group_configuration")

    @log_group_configuration.setter
    def log_group_configuration(self, value: Optional[pulumi.Input['LinkLinkConfigurationLogGroupConfigurationArgs']]):
        pulumi.set(self, "log_group_configuration", value)

    @property
    @pulumi.getter(name="metricConfiguration")
    def metric_configuration(self) -> Optional[pulumi.Input['LinkLinkConfigurationMetricConfigurationArgs']]:
        """
        Configuration for filtering which metric namespaces are to be shared from the source account to the monitoring account. See `metric_configuration` Block for details.
        """
        return pulumi.get(self, "metric_configuration")

    @metric_configuration.setter
    def metric_configuration(self, value: Optional[pulumi.Input['LinkLinkConfigurationMetricConfigurationArgs']]):
        pulumi.set(self, "metric_configuration", value)


if not MYPY:
    class LinkLinkConfigurationLogGroupConfigurationArgsDict(TypedDict):
        filter: pulumi.Input[str]
        """
        Filter string that specifies which log groups are to share their log events with the monitoring account. See [LogGroupConfiguration](https://docs.aws.amazon.com/OAM/latest/APIReference/API_LogGroupConfiguration.html) for details.
        """
elif False:
    LinkLinkConfigurationLogGroupConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class LinkLinkConfigurationLogGroupConfigurationArgs:
    def __init__(__self__, *,
                 filter: pulumi.Input[str]):
        """
        :param pulumi.Input[str] filter: Filter string that specifies which log groups are to share their log events with the monitoring account. See [LogGroupConfiguration](https://docs.aws.amazon.com/OAM/latest/APIReference/API_LogGroupConfiguration.html) for details.
        """
        pulumi.set(__self__, "filter", filter)

    @property
    @pulumi.getter
    def filter(self) -> pulumi.Input[str]:
        """
        Filter string that specifies which log groups are to share their log events with the monitoring account. See [LogGroupConfiguration](https://docs.aws.amazon.com/OAM/latest/APIReference/API_LogGroupConfiguration.html) for details.
        """
        return pulumi.get(self, "filter")

    @filter.setter
    def filter(self, value: pulumi.Input[str]):
        pulumi.set(self, "filter", value)


if not MYPY:
    class LinkLinkConfigurationMetricConfigurationArgsDict(TypedDict):
        filter: pulumi.Input[str]
        """
        Filter string that specifies  which metrics are to be shared with the monitoring account. See [MetricConfiguration](https://docs.aws.amazon.com/OAM/latest/APIReference/API_MetricConfiguration.html) for details.
        """
elif False:
    LinkLinkConfigurationMetricConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class LinkLinkConfigurationMetricConfigurationArgs:
    def __init__(__self__, *,
                 filter: pulumi.Input[str]):
        """
        :param pulumi.Input[str] filter: Filter string that specifies  which metrics are to be shared with the monitoring account. See [MetricConfiguration](https://docs.aws.amazon.com/OAM/latest/APIReference/API_MetricConfiguration.html) for details.
        """
        pulumi.set(__self__, "filter", filter)

    @property
    @pulumi.getter
    def filter(self) -> pulumi.Input[str]:
        """
        Filter string that specifies  which metrics are to be shared with the monitoring account. See [MetricConfiguration](https://docs.aws.amazon.com/OAM/latest/APIReference/API_MetricConfiguration.html) for details.
        """
        return pulumi.get(self, "filter")

    @filter.setter
    def filter(self, value: pulumi.Input[str]):
        pulumi.set(self, "filter", value)


