# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ContactChannelDeliveryAddressArgs',
    'ContactChannelDeliveryAddressArgsDict',
    'PlanStageArgs',
    'PlanStageArgsDict',
    'PlanStageTargetArgs',
    'PlanStageTargetArgsDict',
    'PlanStageTargetChannelTargetInfoArgs',
    'PlanStageTargetChannelTargetInfoArgsDict',
    'PlanStageTargetContactTargetInfoArgs',
    'PlanStageTargetContactTargetInfoArgsDict',
]

MYPY = False

if not MYPY:
    class ContactChannelDeliveryAddressArgsDict(TypedDict):
        simple_address: pulumi.Input[str]
        """
        Details to engage this contact channel. The expected format depends on the contact channel type and is described in the [`ContactChannelAddress` section of the SSM Contacts API Reference](https://docs.aws.amazon.com/incident-manager/latest/APIReference/API_SSMContacts_ContactChannelAddress.html).
        """
elif False:
    ContactChannelDeliveryAddressArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ContactChannelDeliveryAddressArgs:
    def __init__(__self__, *,
                 simple_address: pulumi.Input[str]):
        """
        :param pulumi.Input[str] simple_address: Details to engage this contact channel. The expected format depends on the contact channel type and is described in the [`ContactChannelAddress` section of the SSM Contacts API Reference](https://docs.aws.amazon.com/incident-manager/latest/APIReference/API_SSMContacts_ContactChannelAddress.html).
        """
        pulumi.set(__self__, "simple_address", simple_address)

    @property
    @pulumi.getter(name="simpleAddress")
    def simple_address(self) -> pulumi.Input[str]:
        """
        Details to engage this contact channel. The expected format depends on the contact channel type and is described in the [`ContactChannelAddress` section of the SSM Contacts API Reference](https://docs.aws.amazon.com/incident-manager/latest/APIReference/API_SSMContacts_ContactChannelAddress.html).
        """
        return pulumi.get(self, "simple_address")

    @simple_address.setter
    def simple_address(self, value: pulumi.Input[str]):
        pulumi.set(self, "simple_address", value)


if not MYPY:
    class PlanStageArgsDict(TypedDict):
        duration_in_minutes: pulumi.Input[int]
        """
        The time to wait until beginning the next stage. The duration can only be set to 0 if a target is specified.
        """
        targets: NotRequired[pulumi.Input[Sequence[pulumi.Input['PlanStageTargetArgsDict']]]]
        """
        One or more configuration blocks for specifying the contacts or contact methods that the escalation plan or engagement plan is engaging. See Target below for more details.
        """
elif False:
    PlanStageArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class PlanStageArgs:
    def __init__(__self__, *,
                 duration_in_minutes: pulumi.Input[int],
                 targets: Optional[pulumi.Input[Sequence[pulumi.Input['PlanStageTargetArgs']]]] = None):
        """
        :param pulumi.Input[int] duration_in_minutes: The time to wait until beginning the next stage. The duration can only be set to 0 if a target is specified.
        :param pulumi.Input[Sequence[pulumi.Input['PlanStageTargetArgs']]] targets: One or more configuration blocks for specifying the contacts or contact methods that the escalation plan or engagement plan is engaging. See Target below for more details.
        """
        pulumi.set(__self__, "duration_in_minutes", duration_in_minutes)
        if targets is not None:
            pulumi.set(__self__, "targets", targets)

    @property
    @pulumi.getter(name="durationInMinutes")
    def duration_in_minutes(self) -> pulumi.Input[int]:
        """
        The time to wait until beginning the next stage. The duration can only be set to 0 if a target is specified.
        """
        return pulumi.get(self, "duration_in_minutes")

    @duration_in_minutes.setter
    def duration_in_minutes(self, value: pulumi.Input[int]):
        pulumi.set(self, "duration_in_minutes", value)

    @property
    @pulumi.getter
    def targets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['PlanStageTargetArgs']]]]:
        """
        One or more configuration blocks for specifying the contacts or contact methods that the escalation plan or engagement plan is engaging. See Target below for more details.
        """
        return pulumi.get(self, "targets")

    @targets.setter
    def targets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['PlanStageTargetArgs']]]]):
        pulumi.set(self, "targets", value)


if not MYPY:
    class PlanStageTargetArgsDict(TypedDict):
        channel_target_info: NotRequired[pulumi.Input['PlanStageTargetChannelTargetInfoArgsDict']]
        """
        A configuration block for specifying information about the contact channel that Incident Manager engages. See Channel Target Info for more details.
        """
        contact_target_info: NotRequired[pulumi.Input['PlanStageTargetContactTargetInfoArgsDict']]
        """
        A configuration block for specifying information about the contact that Incident Manager engages. See Contact Target Info for more details.
        """
elif False:
    PlanStageTargetArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class PlanStageTargetArgs:
    def __init__(__self__, *,
                 channel_target_info: Optional[pulumi.Input['PlanStageTargetChannelTargetInfoArgs']] = None,
                 contact_target_info: Optional[pulumi.Input['PlanStageTargetContactTargetInfoArgs']] = None):
        """
        :param pulumi.Input['PlanStageTargetChannelTargetInfoArgs'] channel_target_info: A configuration block for specifying information about the contact channel that Incident Manager engages. See Channel Target Info for more details.
        :param pulumi.Input['PlanStageTargetContactTargetInfoArgs'] contact_target_info: A configuration block for specifying information about the contact that Incident Manager engages. See Contact Target Info for more details.
        """
        if channel_target_info is not None:
            pulumi.set(__self__, "channel_target_info", channel_target_info)
        if contact_target_info is not None:
            pulumi.set(__self__, "contact_target_info", contact_target_info)

    @property
    @pulumi.getter(name="channelTargetInfo")
    def channel_target_info(self) -> Optional[pulumi.Input['PlanStageTargetChannelTargetInfoArgs']]:
        """
        A configuration block for specifying information about the contact channel that Incident Manager engages. See Channel Target Info for more details.
        """
        return pulumi.get(self, "channel_target_info")

    @channel_target_info.setter
    def channel_target_info(self, value: Optional[pulumi.Input['PlanStageTargetChannelTargetInfoArgs']]):
        pulumi.set(self, "channel_target_info", value)

    @property
    @pulumi.getter(name="contactTargetInfo")
    def contact_target_info(self) -> Optional[pulumi.Input['PlanStageTargetContactTargetInfoArgs']]:
        """
        A configuration block for specifying information about the contact that Incident Manager engages. See Contact Target Info for more details.
        """
        return pulumi.get(self, "contact_target_info")

    @contact_target_info.setter
    def contact_target_info(self, value: Optional[pulumi.Input['PlanStageTargetContactTargetInfoArgs']]):
        pulumi.set(self, "contact_target_info", value)


if not MYPY:
    class PlanStageTargetChannelTargetInfoArgsDict(TypedDict):
        contact_channel_id: pulumi.Input[str]
        """
        The Amazon Resource Name (ARN) of the contact channel.
        """
        retry_interval_in_minutes: NotRequired[pulumi.Input[int]]
        """
        The number of minutes to wait before retrying to send engagement if the engagement initially failed.
        """
elif False:
    PlanStageTargetChannelTargetInfoArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class PlanStageTargetChannelTargetInfoArgs:
    def __init__(__self__, *,
                 contact_channel_id: pulumi.Input[str],
                 retry_interval_in_minutes: Optional[pulumi.Input[int]] = None):
        """
        :param pulumi.Input[str] contact_channel_id: The Amazon Resource Name (ARN) of the contact channel.
        :param pulumi.Input[int] retry_interval_in_minutes: The number of minutes to wait before retrying to send engagement if the engagement initially failed.
        """
        pulumi.set(__self__, "contact_channel_id", contact_channel_id)
        if retry_interval_in_minutes is not None:
            pulumi.set(__self__, "retry_interval_in_minutes", retry_interval_in_minutes)

    @property
    @pulumi.getter(name="contactChannelId")
    def contact_channel_id(self) -> pulumi.Input[str]:
        """
        The Amazon Resource Name (ARN) of the contact channel.
        """
        return pulumi.get(self, "contact_channel_id")

    @contact_channel_id.setter
    def contact_channel_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "contact_channel_id", value)

    @property
    @pulumi.getter(name="retryIntervalInMinutes")
    def retry_interval_in_minutes(self) -> Optional[pulumi.Input[int]]:
        """
        The number of minutes to wait before retrying to send engagement if the engagement initially failed.
        """
        return pulumi.get(self, "retry_interval_in_minutes")

    @retry_interval_in_minutes.setter
    def retry_interval_in_minutes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "retry_interval_in_minutes", value)


if not MYPY:
    class PlanStageTargetContactTargetInfoArgsDict(TypedDict):
        is_essential: pulumi.Input[bool]
        """
        A Boolean value determining if the contact's acknowledgement stops the progress of stages in the plan.
        """
        contact_id: NotRequired[pulumi.Input[str]]
        """
        The Amazon Resource Name (ARN) of the contact.
        """
elif False:
    PlanStageTargetContactTargetInfoArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class PlanStageTargetContactTargetInfoArgs:
    def __init__(__self__, *,
                 is_essential: pulumi.Input[bool],
                 contact_id: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[bool] is_essential: A Boolean value determining if the contact's acknowledgement stops the progress of stages in the plan.
        :param pulumi.Input[str] contact_id: The Amazon Resource Name (ARN) of the contact.
        """
        pulumi.set(__self__, "is_essential", is_essential)
        if contact_id is not None:
            pulumi.set(__self__, "contact_id", contact_id)

    @property
    @pulumi.getter(name="isEssential")
    def is_essential(self) -> pulumi.Input[bool]:
        """
        A Boolean value determining if the contact's acknowledgement stops the progress of stages in the plan.
        """
        return pulumi.get(self, "is_essential")

    @is_essential.setter
    def is_essential(self, value: pulumi.Input[bool]):
        pulumi.set(self, "is_essential", value)

    @property
    @pulumi.getter(name="contactId")
    def contact_id(self) -> Optional[pulumi.Input[str]]:
        """
        The Amazon Resource Name (ARN) of the contact.
        """
        return pulumi.get(self, "contact_id")

    @contact_id.setter
    def contact_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "contact_id", value)


